=== debian/changelog ===
ghc-testsuite (8.6.5-1) unstable; urgency=medium

  * New upstream release
  * Update copyright file and Build depends

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 24 Jul 2019 12:23:40 +0200
